import re 
import subprocess

regexp = "(.*) : (.*)" 
prog = re.compile(regexp) 


def add_client(addr) : 
    connections.append(addr) 
    print(connections) 

def del_client(addr) : 
    if addr in connections : 
        connections.remove(addr)
    print(connections) 

def get_program_input() : 
    message = input("Entrez un programme à exécuter...")
    return message

def print_program_return(addr, ret_val) : 
    print("The program executed from " + str(addr) + " return the value " + str(ret_val))

def get_message_type(message) : 
    result=prog.findall(message) 
    if len(result) == 0 : 
        return None, None 
    return str(result[0][0]), str(result[0][1])

def get_data_port(message) : 
    clr_msg  = decode_message(message) 
    mtype, mbody = get_message_type(clr_msg) 
    return int(mbody) 

def encode_message(message) : 
    return str.encode(message) 

def decode_message(raw_message) : 
    return raw_message.decode("utf-8")

def execute_program(program) :
    to_exec = program # executer en tâche de fond.
    ret_val = subprocess.call(program + "&", shell=True)
    return "val : " + str(ret_val)

def handle_message(message): 
    mtype, mbody = get_message_type(message) 
    if mtype is None :
        return None 
    if mtype == "prog" : 
        print("Received prog " + mbody ) 
        ret_val = execute_program(mbody) 
        return ret_val 
    if mtype == "clo" : 
        return -1 
    elif mbody == "ret" : 
        print(message) 
        return None 

def round_robin() : 
    roundrobin_inc = roundrobin_inc + 1 
    print("Roundrobin... inc = " + str(roundrobin_inc)) 
    return roundrobin_inc
